classdef Functional_conductivity < matlab.mixin.Copyable
    properties
        func;
    end
    methods
        % FUNC = function handle of form @(x, y)
        function obj = Functional_conductivity(func)
            obj.func = func;
        end
        
        % Returns a column vector of samples.
        function samples = sample_mesh(obj, mesh)
                xs = sum(mesh.p(mesh.t * 2 - 1), 1)./3;
                ys = sum(mesh.p(mesh.t * 2 - 0), 1)./3;

                samples = obj.func(xs, ys)';
        end
        
        % Returns a column vector of samples.
        function samples = sample_verts(obj, mesh)
            xs = mesh.p(1, :)';
            ys = mesh.p(2, :)';
            samples = obj.func(xs, ys);
        end
        
        function sample = sample(obj, x, y)
                sample = obj.func(x, y);
        end
    end % Methods
end
