classdef Resistance_CEM_electrode_parametrization < Conductance_CEM_electrode_parametrization
    methods
        function p = get_params(obj)
            p = 1./obj.electrode_conductances;
        end
        
        function perturb(obj, eta)
            obj.electrode_conductances(:) = max(min(obj.electrode_conductances(:) ./ (1 + obj.electrode_conductances(:) .* eta(:)), obj.conductance_bounds(2)), obj.conductance_bounds(1));
        end
        
        function derivatives = derivative(obj, Xb, Wb, vdrop2, mesh)
            bp = obj.boundary_params(Xb, mesh);

            pointwise_d = -vdrop2 * Wb .* mesh.affine.detAb;
            derivatives = (-obj.electrode_conductances .^ 2) .* accumarray(bp.electrode_inds(logical(bp.electrode_inds(:, end)), end), pointwise_d(logical(bp.electrode_inds(:, end))));
        end
    end
end