function gauss = gauss_node_dist_prior(mesh, corrdist, weight)
    % GAUSS_NODE_DIST_PRIOR Node distance based covariance
    %   out = GAUSS_NODE_DIST_PRIOR(mesh, correlation_distance, weight)

    xs = mesh.p(1, :)';
    ys = mesh.p(2, :)';
    distssquares = (xs' - xs).^2 + (ys' - ys).^2;
    gauss = weight.^2*exp(-0.5 * (distssquares)./(corrdist.^2));
end