finalerrs = [];

CEM_constant_mids = maybeor('CEM_constant_mids', []);
CEM_constant_finalerrs = maybeor('CEM_constant_finalerrs', []);

% Conductance_CEM_electrode_parametrization doesn't work with
% Generate_data_hard_tank for e.g. case 5.
el_parametrization = Resistance_CEM_electrode_parametrization(mesh);
el_widths = coly(maybeor('el_width ./ (el_extension_width + el_width)', 1.0));
el_parametrization.electrode_domain = maybeor('[clamp(0.5 - (ones(Ne, 1) .* el_widths ./ 2), 0, 1 - el_widths), clamp(0.5 + (ones(Ne, 1) .* el_widths ./ 2), el_widths, 1)]', [zeros(Ne, 1), ones(Ne, 1)]);
el_parametrization.set_resistors(1000);

electrodes = Functional_electrodes(mesh, el_parametrization);

dom_parametrization = Constant_log_domain_parametrization(mesh);
dom_parametrization.conductivity_bounds = [10^-6 10^6];
dom_parametrization.set_constant(10^-3);

fm = CEM_forward_model(mesh, dom_parametrization, electrodes, current_plan);




fm.use_log = 1;
for snip = 1 % Figures
    if maybeor('not(DISABLE_DRAW)', 0)
        %h_cond = figure(1); colormap(mycolormap(100)); clf;
        h_iter = figure(2); colormap('gray'); clf;
        %h_grad = figure(3); colormap('gray'); clf;
        h_step = figure(4); colormap(mycolormap(255)); clf;
%         h_exact = figure(5); colormap('gray'); clf;
%         h_electrodes = figure(6); clf;
        %h_volts = figure(7); clf;
    end
end

for snip = 1 % Plotting
    if maybeor('not(DISABLE_DRAW)', 0)
        set(0, 'CurrentFigure', h_iter); clf;
        fm.draw_conductivity_field(); colorbar; view(0, 90); labels; title('Iter conductivity'); drawnow;
    end
end
electrodes.label_electrodes(1, mesh, [zeros(fm.solution_structure.domain(1) + electrodes.Ne, 1)], fm.get_scaler());

x0 = [zeros(fm.perturbation_structure.domain, 1);
      zeros(fm.perturbation_structure.electrode_conductances, 1)];

alpha_domain = 0;
alpha_electrode = 0;
a_vec = [alpha_domain * ones(fm.perturbation_structure.domain, 1);
         alpha_electrode * ones(fm.perturbation_structure.electrode_conductances, 1)];  
aLL = a_vec * a_vec';


EIT_minimization();


finalerrs(end+1, :) = [mean(fm.domain_parametrization.get_params_as_conductivity()) / 0.05, ...
                       norm(accuratevolts(:) - volts(:)), ...
                       (fm.domain_parametrization.get_params() - x0(1:fm.perturbation_structure.domain))' * aLL(1:fm.perturbation_structure.domain, 1:fm.perturbation_structure.domain) * (fm.domain_parametrization.get_params() - x0(1:fm.perturbation_structure.domain)), ...
                       (fm.electrode_model.parametrization.get_params() - x0(fm.perturbation_structure.domain+1:end))' * aLL(fm.perturbation_structure.domain+1:end, fm.perturbation_structure.domain+1:end) * (fm.electrode_model.parametrization.get_params() - x0(fm.perturbation_structure.domain+1:end))]

[~, temp_mids] = fm.electrode_model.conductance_integrals();
CEM_constant_mids(:, end+1) = temp_mids;
CEM_constant_finalerrs(end+1, :) = finalerrs(end, :);