function draw_contact(fm, el_ind, line_fmt, point_fmt, tank_height)
    if nargin == 0
        fm = evalin('base', 'fm');
    end
    if nargin < 2
        el_ind = 1;
    end

    if nargin >= 3
        ph = fm.electrode_model.plot_electrodes_conductances(el_ind, 1./tank_height, line_fmt);
    else
        ph = fm.electrode_model.plot_electrodes_conductances(el_ind, 1./tank_height);
    end

    title(sprintf('Electrode %d', el_ind)); hold on;
    set(ph, 'LineWidth', 1.5);

    [~, mids] = fm.electrode_model.conductance_integrals();
    if nargin >= 4
        myplot(mids(el_ind), 0, point_fmt);
    else
        myplot(mids(el_ind), 0);
    end
end
