function RGB = mylab2rgb(LAB)
	% LAB to XYZ
	finvLAB = zeros(size(LAB));
    Xfinvarg = (LAB(:, 1) + 0.16) / 1.16 + LAB(:, 2) / 5.00;
    Yfinvarg = (LAB(:, 1) + 0.16) / 1.16;
    Zfinvarg = (LAB(:, 1) + 0.16) / 1.16 - LAB(:, 3) / 2.00;
    
    XfT = Xfinvarg > 6/2900;
    YfT = Yfinvarg > 6/2900;
    ZfT = Zfinvarg > 6/2900;
    finvLAB(:, 1) = XfT .* Xfinvarg.^3 + (~XfT).*3 .* (6/2900).^3 .* (Xfinvarg - 4/2900);
    finvLAB(:, 2) = YfT .* Yfinvarg.^3 + (~YfT).*3 .* (6/2900).^3 .* (Yfinvarg - 4/2900);
    finvLAB(:, 3) = ZfT .* Zfinvarg.^3 + (~ZfT).*3 .* (6/2900).^3 .* (Zfinvarg - 4/2900);
    
    XYZ = [0.95047.*finvLAB(:, 1), 1.000.*finvLAB(:, 2), 1.08883.*finvLAB(:, 3)];

    % XYZ to rgb
    Minv = [3.2404542, -1.5371385, -0.4985314;
    		-0.9692660, 1.8760108, 0.0415560;
    		0.0556434, -0.2040259, 1.0572252];
    rgb = (Minv*(XYZ.')).';

    % Add gamma
   	RGB = zeros(size(rgb));
   	RGB(rgb <= 0.0031308) = 12.92.*rgb(rgb <= 0.0031308);
   	RGB(rgb > 0.0031308) = 1.055.*rgb(rgb > 0.0031308).^(1/2.4) - 0.055;
end
