function ph = myplot(varargin)
    expanded_args = {};
    for arg_ind = 1:length(varargin)
        val = varargin{arg_ind};
        if not(isstring(val) || ischar(val))
            expanded_args{end+1} = val;
            continue
        end

        strval = string(val);
        if not(startsWith(strval, "#"))
            expanded_args{end+1} = val;
            continue;
        end

        try
            [hexval, tail] = try_extract_hex(strval);
            expanded_args{end+1} = tail;
            expanded_args{end+1} = 'Color';
            expanded_args{end+1} = hexval;
        catch ME
            if strcmp(ME.identifier, 'My:InvalidHEX')
                warning(ME.message);
                expanded_args{end+1} = val;
            else
                rethrow(ME);
            end
        end
    end
    
    if nargout == 1
        ph = plot(expanded_args{:});
    else
        plot(expanded_args{:});
    end
end

function [hexval, tail] = try_extract_hex(str)
    if startsWith(str, "#")
        if strlength(str) >= 7
            maybe_hex = extractBetween(str, 2, 7);
            if regexp(maybe_hex, "[0-9a-fA-F]{6}")
                hex_str_arr = [extractBetween(maybe_hex, 1, 2) extractBetween(maybe_hex, 3, 4) extractBetween(maybe_hex, 5, 6)];
                hexval = [];
                for sub_hex = hex_str_arr
                    hexval(end+1) = sscanf(sub_hex, "%x");
                end
                hexval = hexval / 255;
                tail = extractAfter(str, 7);
                return;
            end
        elseif strlength(str) >= 3
            maybe_l = extractBetween(str, 2, 2);
            maybe_digit = extractBetween(str, 3, 3);
            if (strcmp(maybe_l, "l") && regexp(maybe_digit, "[1-7]"))
                col_list = [0.0000, 0.4470, 0.7410;
                            0.8500, 0.3250, 0.0980;
                            0.9290, 0.6940, 0.1250;
                            0.4940, 0.1840, 0.5560;
                            0.4660, 0.6740, 0.1880;
                            0.3010, 0.7450, 0.9330;
                            0.6350, 0.0780, 0.1840]; % Matlab default colors
                col_ind = sscanf(maybe_digit, "%u");
                hexval = col_list(col_ind, :);
                tail = extractAfter(str, 3);
                return;
            end
        end
        throw(MException('My:InvalidHEX', "%s doesn't begin with a valid hexadecimal color code although it begins with #.", str));
    end
end
