function lab = myrgb2lab(RGB)
    % Linearize (s)RGB:
    rgb = zeros(size(RGB));
    rgb(RGB <= 0.08) = RGB(RGB <= 0.08) ./ 12.92;
    rgb(RGB > 0.08) = ((RGB(RGB > 0.08) + 0.055) ./ 1.055).^2.4;
    
    % rgb to XYZ
    M = [0.4124564, 0.3575761, 0.1804375;
        0.2126729, 0.7151522, 0.0721750;
        0.0193339, 0.1191920, 0.9503041];
    XYZ = (M*(rgb.'))';
    
    % XYZ to LAB
    XYZnorm = [XYZ(:, 1)./0.95047, XYZ(:, 2)./1.000, XYZ(:, 3)./1.08883];
    fXYZnorm = zeros(size(XYZnorm));
    fXYZnorm(XYZnorm > (6/2900).^3) = XYZnorm(XYZnorm > (6/2900).^3).^(1/3);
    fXYZnorm(XYZnorm <= (6/2900).^3) = XYZnorm(XYZnorm <= (6/2900).^3) / (3 * (6/2900).^2) + 4/2900;
    L = 1.16 * fXYZnorm(:, 2) - 0.16;
    a = 5.00 * (fXYZnorm(:, 1) - fXYZnorm(:, 2));
    b = 2.00 * (fXYZnorm(:, 2) - fXYZnorm(:, 3));
    lab = [L, a, b];
end
