classdef Bidir_circ_iter < matlab.mixin.Copyable
    properties
        data;
        state;
        N;
    end
    methods (Hidden = true, Static = true)
        function incd = circ_ind_inc(val, N)
            incd = mod(val, N) + 1;
        end
        function decd = circ_ind_dec(val, N)
            decd = mod(val - 2, N) + 1;
        end
    end
    methods
        function obj = Bidir_circ_iter(data, state)
            if (nargin == 1)
                state = 1;
            end
            obj.data = data;
            obj.state = state;
            obj.N = size(data, 1);
        end
        
        function new = next(obj)
            new = Bidir_circ_iter(obj.data, obj.circ_ind_inc(obj.state, obj.N));
        end
        
        function new = prev(obj)
            new = Bidir_circ_iter(obj.data, obj.circ_ind_dec(obj.state, obj.N));
        end
        
        function row = get(obj)
            row = obj.data(obj.state, :);
        end
        
        function set(obj, row)
            obj.data(obj.state, :) = row;
        end

        function row = get_next(obj)
            row = obj.data(obj.circ_ind_inc(obj.state, obj.N), :);
        end
        
        function set_next(obj, row)
            obj.data(obj.circ_ind_inc(obj.state, obj.N), :) = row;
        end
        
        function row = get_prev(obj)
            row = obj.data(obj.circ_ind_dec(obj.state, obj.N), :);
        end

        function row = set_prev(obj, row)
            obj.data(obj.circ_ind_dec(obj.state, obj.N), :) = row;
        end
        
        function to(obj, pos)
            if not(strcmpi(pos, "begin"))
                pos = 1;
            elseif not(strcmpi(pos, "end"))
                pos = obj.N
            end
            obj.state = pos;
        end
    end
end