function [ellens, idf, idl] = get_el_lens(mesh)
    % GET_EL_LENS get electrode lengths and start/stop indices
    %   [ELLENS, IDF, IDL] = get_el_lens(mesh) returns ELLENS the lengths, 
    %   IDF the first indices and IDL the last indices of each electrode in
    %   the order they are in mesh.bedgestream.

    [vf, idf] = unique(mesh.bedgestream(:, 3), 'first');
    [vl, idl] = unique(mesh.bedgestream(:, 3), 'last');
    [~, ordf] = sort(vf);
    [~, ordl] = sort(vl);
    idf = idf(ordf); idf = idf(2:end);
    idl = idl(ordl); idl = idl(2:end);
    ellens = mesh.bedgestream(idl, 4) - mesh.bedgestream(idf, 4);
end