function us = zeromeangramschmidt(A)
    A = [ones(size(A, 1), 1) A];
    if (rank(A) ~= max(size(A)))
        error("Attempting to Gram-Schmidt a rank-deficient matrix.");
    end
    us = zeros(size(A));
    for vi = 1:size(A, 2)
        us(:, vi) = A(:, vi);
        for ui = 1:vi-1
            us(:, vi) = us(:, vi) - (us(:, vi).' * us(:, ui)) * us(:, ui);
        end
        us(:, vi) = us(:, vi) ./ norm(us(:, vi));
    end
    us = us(:, 2:end);
end