% N is the number of columns (or basis functions)
% Produces patterns like
% A= [
% 1 0 0 0 0 0 0 0 0 0 0 0 0
% 0 1 0 0 0 0 0 0 0 0 0 0 0
% 1 0 1 0 0 0 0 0 0 0 0 0 0
% 0 1 0 1 0 0 0 0 0 0 0 0 0
% 1 0 0 0 1 0 0 0 0 0 0 0 0
% 0 1 0 0 0 1 0 0 0 0 0 0 0
% 1 0 1 0 0 0 1 0 0 0 0 0 0
% 0 1 0 1 0 0 0 1 0 0 0 0 0
% 1 0 0 0 0 0 0 0 1 0 0 0 0
% 0 1 0 0 0 0 0 0 0 1 0 0 0
% 1 0 1 0 0 0 0 0 0 0 1 0 0
% 0 1 0 1 0 0 0 0 0 0 0 1 0
% 1 0 0 0 1 0 0 0 0 0 0 0 1
% 0 0 0 0 0 0 0 0 0 0 0 0 0
% ]

function pattern = zeromeanpattern(N)
    pattern = zeros(N+1, N);
    for col = 1:N
        gaplength = 2*max(floortobin(col-1), 1);
        gap = 0;
        for row = col:N
            if (mod(gap, gaplength) == 0)
                pattern(row, col) = 1;
            end
            gap = gap + 1;
        end
    end
end
